=== source/gmqcc/distro/Makefile ===
DROPBOX := dropbox_uploader.sh
UNAME   := $(shell uname -m)
DOWNLOAD:= ../doc/html/download.c
BRANCH  := $(shell git branch | sed -n -e 's/^\* \(.*\)/\1/p')
ifneq ($(shell uname -m), x86_64)
    $(error Cannot build packages without an x86_64 capable CPU)
endif

.NOTPARALLEL: base
.NOTPARALLEL: upload

base:
	$(MAKE) -C deb/
	$(MAKE) -C deb/ CARCH=i686
	$(MAKE) -C archlinux/this/
	$(MAKE) -C archlinux/this/ CARCH=i686
	$(MAKE) -C win32/
	@mv deb/*.deb ./
	@mv archlinux/this/*pkg.tar.xz ./
	@mv win32/*.zip ./

upload:
	@echo "APPKEY:76vh3q42hnvmzm3" > dropbox_config
	@echo "APPSECRET:tmeecht2cmh72xa" >> dropbox_config
	@echo "ACCESS_LEVEL:sandbox" >> dropbox_config
	@echo "OAUTH_ACCESS_TOKEN:w0bxzf0dft8edfq" >> dropbox_config
	@echo "OAUTH_ACCESS_TOKEN_SECRET:9vosx7x8gy4kgjk" >> dropbox_config
	@wget -q "http://raw.github.com/andreafabrizi/Dropbox-Uploader/master/dropbox_uploader.sh"
	@chmod +x dropbox_uploader.sh
	@sed -i -e "s/~\/.dropbox_uploader/.\/dropbox_config/g" $$(basename $(DROPBOX))
	@find . -type f -regex ".*/.*\.\(xz\|deb\|zip\)" -exec ./$$(basename $(DROPBOX)) upload {} \;
	@rm dropbox_config dropbox_uploader.sh

website:
	$(CC) $(DOWNLOAD) -o html.gen
	@./html.gen ../
	@rm html.gen
	@git stash
	@git checkout gh-pages
	@rm -f ../download.html
	@mv -f download.html ../download.html
	@cd ..; git add download.html; git commit -m 'update download page'; git push origin gh-pages;
	@git checkout $(BRANCH)
	@git stash apply

clean:
	@rm -f *.deb
	@rm -f *.pkg.tar.xz
	@rm -f *.zip
	@rm -f *.gen
	@rm -f *.html

all: base upload
