=== source/gmqcc/distro/archbsd/release/PKGBUILD ===
# Contributor: matthiaskrgr <matthiaskrgr _strange_curverd_character_ freedroid D0T org>
# Contributor: Wolfgang Bumiller <blub@speed.at>

pkgname=gmqcc
pkgver=0.2.9
pkgrel=1
pkgdesc="An Improved Quake C Compiler"
arch=('i686' 'x86_64')
depends=()
url="https://github.com/graphitemaster/gmqcc.git"
license=('MIT')
source=(gmqcc-$pkgver.zip::https://github.com/graphitemaster/gmqcc/zipball/$pkgver)
sha1sums=('adf972360c0b3d2f032a688952f6fb4715e4d45b')

_gitname=graphitemaster-gmqcc-219508e/

build() {
	msg "Starting compilation..."
	cd "$srcdir"/"$_gitname"

	msg "Compiling..."
	gmake
}

check() {
	cd "$srcdir"/"$_gitname"
	gmake check
}

package() {
	cd "$srcdir"/"$_gitname"
	msg "Compiling and installing to pkgdir this time..."
	gmake install DESTDIR=$pkgdir PREFIX=/usr
	msg "Compiling done."

	install -dm755 ${pkgdir}/usr/share/licenses/gmqcc
	install -m644 LICENSE ${pkgdir}/usr/share/licenses/gmqcc/LICENSE
}
